module Hangfu
  class Bank
    attr_reader :words
    attr_reader :occurances
    
    def initialize(list)
      @words = []
      list.each do |w|
        @words << w
      end
      @excluded = []
    end
    
    def exclude(mask)
      mask.each_byte do |byte|
        next if byte.chr == '_'
        @excluded << byte.chr unless @excluded.include?(byte.chr)
      end
    end
    
    def remove_length!(length)
      @words.reject! {|w| w.size != length }
    end
    
    def remove_words_with_letter!(letter)
      @words.reject! {|w| w.include?(letter) }
    end
    
    def remove_words_missing_mask!(mask)
      matcher = Regexp.new(mask.gsub('_', '\w'))
      words.reject! do |word|
        !matcher.match(word)
      end
    end
    
    def lucky_letter
      analyze!
      most_occured_letter
    end
    
    def most_occured_letter
      @occurances.max {|a, b| a[1] <=> b[1]}[0]
    end
    
    def analyze!
      @occurances = {}
      (('a'..'z').to_a - @excluded).each {|l| @occurances[l] = 0}
      @words.each do |word|
        word.each_byte do |byte|
          @occurances[byte.chr] += 1 if @occurances.has_key?(byte.chr)
        end
      end
    end
  end
end