require File.dirname(__FILE__) + '/bank'

module Hangfu
  class Hangfu
    
    attr_accessor :bank
    
    # You may initialize you player but the the initialize method must take NO paramters.
    # The player will only be instantiated once, and will play many games.
    def initialize
    end

    # Before starting a game, this method will be called to inform the player of all the possible words that may be
    # played.
    def word_list=(list)
      @list = list
      @bank = Bank.new(list)
    end

    # a new game has started.  The number of guesses the player has left is passed in (default 6),
    # in case you want to keep track of it.
    def new_game(guesses_left)
      @bank = Bank.new(@list)
    end

    # Each turn your player must make a guess.  The word will be a bunch of underscores, one for each letter in the word.
    # after your first turn, correct guesses will appear in the word parameter.  If the word was "shoes" and you guessed "s",
    # the word parameter would be "s___s", if you then guess 'o', the next turn it would be "s_o_s", and so on.
    # guesses_left is how many guesses you have left before your player is hung.
    def guess(word, guesses_left)
      @bank.remove_length! word.size
      @bank.remove_words_missing_mask! word
      @bank.exclude(word)
      @bank.lucky_letter
    end
    
    # notifies you that your last guess was incorrect, and passes your guess back to the method
    def incorrect_guess(guess)
      @bank.remove_words_with_letter! guess
    end

    # notifies you that your last guess was correct, and passes your guess back to the method
    def correct_guess(guess)
      @bank.exclude guess
    end

    # you lost the game.  The reason is in the reason parameter
    def fail(reason)
    end

    # The result of the game, it'll be one of 'win', 'loss', or 'fail'.
    # The spelled out word will be provided regardless of the result.
    def game_result(result, word)
    end
  end
end