require File.expand_path(File.dirname(__FILE__) + "/../spec_helper")
require 'hangfu/hangfu'
require 'hangfu/bank'

module Hangfu
  
  describe "A bank instance with a list of words" do
    before(:each) do
      @sample_word_list = ["rabbit", "horse", "snake", "chipmunk", "cat", "dog", "frog", "toad", "bird", "hawk", "elephant", "zebra", "lion", "tiger", "lizard", "fish", "whale", "minnow", "monkey", "eagle", "worm", "ant", "goat", "cow", "pig", "camel", "donkey", "worm", "turtle", "alligator", "crocodile", "cheetah", "robin", "dove", "fly", "butterfly", "mouse", "hamster", "rat", "bat", "stork", "falcon", "sparrow", "leopard", "bear"]
      @bank = Bank.new(@sample_word_list)
    end
  
    it "has words" do
      @bank.words.should == @sample_word_list
    end
    
    it "removes words that are 5 charactors long" do
      @bank.remove_length!("_____")
      
      @bank.words.each do |word|
        word.size.should_not == 5
      end
    end
    
    it "should have a as lucky letter" do
      @bank.lucky_letter.should == 'a'
    end
  end
end